/*
 * Copyright (c) 2016-2022 VMware, Inc. All Rights Reserved.
 * This software is released under MIT license.
 * The full license information can be found in LICENSE in the root directory of this project.
 */

import { ClrSelectedState } from '@clr/angular';

export interface TreeNode {
  name: string;
  selected?: ClrSelectedState;
  children?: TreeNode[];
}

const states = [
  {
    name: 'New York',
    cities: [
      { name: 'New York' },
      { name: 'Buffalo' },
      { name: 'Rochester' },
      { name: 'Yonkers' },
      { name: 'Syracuse' },
      { name: 'Albany' },
      { name: 'New Rochelle' },
      { name: 'Mount Vernon' },
      { name: 'Schenectady' },
      { name: 'Utica' },
      { name: 'White Plains' },
      { name: 'Hempstead' },
      { name: 'Troy' },
      { name: 'Niagara Falls' },
      { name: 'Binghamton' },
      { name: 'Freeport' },
      { name: 'Valley Stream' },
    ],
  },
  {
    name: 'California',
    cities: [
      { name: 'Los Angeles' },
      { name: 'San Diego' },
      { name: 'San Jose' },
      { name: 'San Francisco' },
      { name: 'Fresno' },
      { name: 'Sacramento' },
      { name: 'Long Beach' },
      { name: 'Oakland' },
      { name: 'Bakersfield' },
      { name: 'Anaheim' },
      { name: 'Santa Ana' },
      { name: 'Riverside' },
      { name: 'Stockton' },
      { name: 'Chula Vista' },
      { name: 'Irvine' },
      { name: 'Fremont' },
      { name: 'San Bernardino' },
      { name: 'Modesto' },
      { name: 'Fontana' },
      { name: 'Oxnard' },
      { name: 'Moreno Valley' },
      { name: 'Huntington Beach' },
      { name: 'Glendale' },
      { name: 'Santa Clarita' },
      { name: 'Garden Grove' },
      { name: 'Oceanside' },
      { name: 'Rancho Cucamonga' },
      { name: 'Santa Rosa' },
      { name: 'Ontario' },
      { name: 'Lancaster' },
      { name: 'Elk Grove' },
      { name: 'Corona' },
      { name: 'Palmdale' },
      { name: 'Salinas' },
      { name: 'Pomona' },
      { name: 'Hayward' },
      { name: 'Escondido' },
      { name: 'Torrance' },
      { name: 'Sunnyvale' },
      { name: 'Orange' },
      { name: 'Fullerton' },
      { name: 'Pasadena' },
      { name: 'Thousand Oaks' },
      { name: 'Visalia' },
      { name: 'Simi Valley' },
      { name: 'Concord' },
      { name: 'Roseville' },
      { name: 'Victorville' },
      { name: 'Santa Clara' },
      { name: 'Vallejo' },
      { name: 'Berkeley' },
      { name: 'El Monte' },
      { name: 'Downey' },
      { name: 'Costa Mesa' },
      { name: 'Inglewood' },
      { name: 'Carlsbad' },
      { name: 'San Buenaventura (Ventura)' },
      { name: 'Fairfield' },
      { name: 'West Covina' },
      { name: 'Murrieta' },
      { name: 'Richmond' },
      { name: 'Norwalk' },
      { name: 'Antioch' },
      { name: 'Temecula' },
      { name: 'Burbank' },
      { name: 'Daly City' },
      { name: 'Rialto' },
      { name: 'Santa Maria' },
      { name: 'El Cajon' },
      { name: 'San Mateo' },
      { name: 'Clovis' },
      { name: 'Compton' },
      { name: 'Jurupa Valley' },
      { name: 'Vista' },
      { name: 'South Gate' },
      { name: 'Mission Viejo' },
      { name: 'Vacaville' },
      { name: 'Carson' },
      { name: 'Hesperia' },
      { name: 'Santa Monica' },
      { name: 'Westminster' },
      { name: 'Redding' },
      { name: 'Santa Barbara' },
      { name: 'Chico' },
      { name: 'Newport Beach' },
      { name: 'San Leandro' },
      { name: 'San Marcos' },
      { name: 'Whittier' },
      { name: 'Hawthorne' },
      { name: 'Citrus Heights' },
      { name: 'Tracy' },
      { name: 'Alhambra' },
      { name: 'Livermore' },
      { name: 'Buena Park' },
      { name: 'Menifee' },
      { name: 'Hemet' },
      { name: 'Lakewood' },
      { name: 'Merced' },
      { name: 'Chino' },
      { name: 'Indio' },
      { name: 'Redwood City' },
      { name: 'Lake Forest' },
      { name: 'Napa' },
      { name: 'Tustin' },
      { name: 'Bellflower' },
      { name: 'Mountain View' },
      { name: 'Chino Hills' },
      { name: 'Baldwin Park' },
      { name: 'Alameda' },
      { name: 'Upland' },
      { name: 'San Ramon' },
      { name: 'Folsom' },
      { name: 'Pleasanton' },
      { name: 'Union City' },
      { name: 'Perris' },
      { name: 'Manteca' },
      { name: 'Lynwood' },
      { name: 'Apple Valley' },
      { name: 'Redlands' },
      { name: 'Turlock' },
      { name: 'Milpitas' },
      { name: 'Redondo Beach' },
      { name: 'Rancho Cordova' },
      { name: 'Yorba Linda' },
      { name: 'Palo Alto' },
      { name: 'Davis' },
      { name: 'Camarillo' },
      { name: 'Walnut Creek' },
      { name: 'Pittsburg' },
      { name: 'South San Francisco' },
      { name: 'Yuba City' },
      { name: 'San Clemente' },
      { name: 'Laguna Niguel' },
      { name: 'Pico Rivera' },
      { name: 'Montebello' },
      { name: 'Lodi' },
      { name: 'Madera' },
      { name: 'Santa Cruz' },
      { name: 'La Habra' },
      { name: 'Encinitas' },
      { name: 'Monterey Park' },
      { name: 'Tulare' },
      { name: 'Cupertino' },
      { name: 'Gardena' },
      { name: 'National City' },
      { name: 'Rocklin' },
      { name: 'Petaluma' },
      { name: 'Huntington Park' },
      { name: 'San Rafael' },
      { name: 'La Mesa' },
      { name: 'Arcadia' },
      { name: 'Fountain Valley' },
      { name: 'Diamond Bar' },
      { name: 'Woodland' },
      { name: 'Santee' },
      { name: 'Lake Elsinore' },
      { name: 'Porterville' },
      { name: 'Paramount' },
      { name: 'Eastvale' },
      { name: 'Rosemead' },
      { name: 'Hanford' },
      { name: 'Highland' },
      { name: 'Brentwood' },
      { name: 'Novato' },
      { name: 'Colton' },
      { name: 'Cathedral City' },
      { name: 'Delano' },
      { name: 'Yucaipa' },
      { name: 'Watsonville' },
      { name: 'Placentia' },
      { name: 'Glendora' },
      { name: 'Gilroy' },
      { name: 'Palm Desert' },
      { name: 'Cerritos' },
      { name: 'West Sacramento' },
      { name: 'Aliso Viejo' },
      { name: 'Poway' },
      { name: 'La Mirada' },
      { name: 'Rancho Santa Margarita' },
      { name: 'Cypress' },
      { name: 'Dublin' },
      { name: 'Covina' },
      { name: 'Azusa' },
      { name: 'Palm Springs' },
      { name: 'San Luis Obispo' },
      { name: 'Ceres' },
      { name: 'San Jacinto' },
      { name: 'Lincoln' },
      { name: 'Newark' },
      { name: 'Lompoc' },
      { name: 'El Centro' },
      { name: 'Danville' },
      { name: 'Bell Gardens' },
      { name: 'Coachella' },
      { name: 'Rancho Palos Verdes' },
      { name: 'San Bruno' },
      { name: 'Rohnert Park' },
      { name: 'Brea' },
      { name: 'La Puente' },
      { name: 'Campbell' },
      { name: 'San Gabriel' },
      { name: 'Beaumont' },
      { name: 'Morgan Hill' },
      { name: 'Culver City' },
      { name: 'Calexico' },
      { name: 'Stanton' },
      { name: 'La Quinta' },
      { name: 'Pacifica' },
      { name: 'Montclair' },
      { name: 'Oakley' },
      { name: 'Monrovia' },
      { name: 'Los Banos' },
      { name: 'Martinez' },
    ],
  },
  {
    name: 'Illinois',
    cities: [
      { name: 'Chicago' },
      { name: 'Aurora' },
      { name: 'Rockford' },
      { name: 'Joliet' },
      { name: 'Naperville' },
      { name: 'Springfield' },
      { name: 'Peoria' },
      { name: 'Elgin' },
      { name: 'Waukegan' },
      { name: 'Cicero' },
      { name: 'Champaign' },
      { name: 'Bloomington' },
      { name: 'Arlington Heights' },
      { name: 'Evanston' },
      { name: 'Decatur' },
      { name: 'Schaumburg' },
      { name: 'Bolingbrook' },
      { name: 'Palatine' },
      { name: 'Skokie' },
      { name: 'Des Plaines' },
      { name: 'Orland Park' },
      { name: 'Tinley Park' },
      { name: 'Oak Lawn' },
      { name: 'Berwyn' },
      { name: 'Mount Prospect' },
      { name: 'Normal' },
      { name: 'Wheaton' },
      { name: 'Hoffman Estates' },
      { name: 'Oak Park' },
      { name: 'Downers Grove' },
      { name: 'Elmhurst' },
      { name: 'Glenview' },
      { name: 'DeKalb' },
      { name: 'Lombard' },
      { name: 'Belleville' },
      { name: 'Moline' },
      { name: 'Buffalo Grove' },
      { name: 'Bartlett' },
      { name: 'Urbana' },
      { name: 'Quincy' },
      { name: 'Crystal Lake' },
      { name: 'Plainfield' },
      { name: 'Streamwood' },
      { name: 'Carol Stream' },
      { name: 'Romeoville' },
      { name: 'Rock Island' },
      { name: 'Hanover Park' },
      { name: 'Carpentersville' },
      { name: 'Wheeling' },
      { name: 'Park Ridge' },
      { name: 'Addison' },
      { name: 'Calumet City' },
    ],
  },
  {
    name: 'Texas',
    cities: [
      { name: 'Houston' },
      { name: 'San Antonio' },
      { name: 'Dallas' },
      { name: 'Austin' },
      { name: 'Fort Worth' },
      { name: 'El Paso' },
      { name: 'Arlington' },
      { name: 'Corpus Christi' },
      { name: 'Plano' },
      { name: 'Laredo' },
      { name: 'Lubbock' },
      { name: 'Garland' },
      { name: 'Irving' },
      { name: 'Amarillo' },
      { name: 'Grand Prairie' },
      { name: 'Brownsville' },
      { name: 'Pasadena' },
      { name: 'McKinney' },
      { name: 'Mesquite' },
      { name: 'McAllen' },
      { name: 'Killeen' },
      { name: 'Frisco' },
      { name: 'Waco' },
      { name: 'Carrollton' },
      { name: 'Denton' },
      { name: 'Midland' },
      { name: 'Abilene' },
      { name: 'Beaumont' },
      { name: 'Round Rock' },
      { name: 'Odessa' },
      { name: 'Wichita Falls' },
      { name: 'Richardson' },
      { name: 'Lewisville' },
      { name: 'Tyler' },
      { name: 'College Station' },
      { name: 'Pearland' },
      { name: 'San Angelo' },
      { name: 'Allen' },
      { name: 'League City' },
      { name: 'Sugar Land' },
      { name: 'Longview' },
      { name: 'Edinburg' },
      { name: 'Mission' },
      { name: 'Bryan' },
      { name: 'Baytown' },
      { name: 'Pharr' },
      { name: 'Temple' },
      { name: 'Missouri City' },
      { name: 'Flower Mound' },
      { name: 'Harlingen' },
      { name: 'North Richland Hills' },
      { name: 'Victoria' },
      { name: 'Conroe' },
      { name: 'New Braunfels' },
      { name: 'Mansfield' },
      { name: 'Cedar Park' },
      { name: 'Rowlett' },
      { name: 'Port Arthur' },
      { name: 'Euless' },
      { name: 'Georgetown' },
      { name: 'Pflugerville' },
      { name: 'DeSoto' },
      { name: 'San Marcos' },
      { name: 'Grapevine' },
      { name: 'Bedford' },
      { name: 'Galveston' },
      { name: 'Cedar Hill' },
      { name: 'Texas City' },
      { name: 'Wylie' },
      { name: 'Haltom City' },
      { name: 'Keller' },
      { name: 'Coppell' },
      { name: 'Rockwall' },
      { name: 'Huntsville' },
      { name: 'Duncanville' },
      { name: 'Sherman' },
      { name: 'The Colony' },
      { name: 'Burleson' },
      { name: 'Hurst' },
      { name: 'Lancaster' },
      { name: 'Texarkana' },
      { name: 'Friendswood' },
      { name: 'Weslaco' },
    ],
  },
  {
    name: 'Pennsylvania',
    cities: [
      { name: 'Philadelphia' },
      { name: 'Pittsburgh' },
      { name: 'Allentown' },
      { name: 'Erie' },
      { name: 'Reading' },
      { name: 'Scranton' },
      { name: 'Bethlehem' },
      { name: 'Lancaster' },
      { name: 'Harrisburg' },
      { name: 'Altoona' },
      { name: 'York' },
      { name: 'State College' },
      { name: 'Wilkes-Barre' },
    ],
  },
  {
    name: 'Arizona',
    cities: [
      { name: 'Phoenix' },
      { name: 'Tucson' },
      { name: 'Mesa' },
      { name: 'Chandler' },
      { name: 'Glendale' },
      { name: 'Scottsdale' },
      { name: 'Gilbert' },
      { name: 'Tempe' },
      { name: 'Peoria' },
      { name: 'Surprise' },
      { name: 'Yuma' },
      { name: 'Avondale' },
      { name: 'Goodyear' },
      { name: 'Flagstaff' },
      { name: 'Buckeye' },
      { name: 'Lake Havasu City' },
      { name: 'Casa Grande' },
      { name: 'Sierra Vista' },
      { name: 'Maricopa' },
      { name: 'Oro Valley' },
      { name: 'Prescott' },
      { name: 'Bullhead City' },
      { name: 'Prescott Valley' },
      { name: 'Marana' },
      { name: 'Apache Junction' },
    ],
  },
  {
    name: 'Florida',
    cities: [
      { name: 'Jacksonville' },
      { name: 'Miami' },
      { name: 'Tampa' },
      { name: 'Orlando' },
      { name: 'St. Petersburg' },
      { name: 'Hialeah' },
      { name: 'Tallahassee' },
      { name: 'Fort Lauderdale' },
      { name: 'Port St. Lucie' },
      { name: 'Cape Coral' },
      { name: 'Pembroke Pines' },
      { name: 'Hollywood' },
      { name: 'Miramar' },
      { name: 'Gainesville' },
      { name: 'Coral Springs' },
      { name: 'Miami Gardens' },
      { name: 'Clearwater' },
      { name: 'Palm Bay' },
      { name: 'Pompano Beach' },
      { name: 'West Palm Beach' },
      { name: 'Lakeland' },
      { name: 'Davie' },
      { name: 'Miami Beach' },
      { name: 'Sunrise' },
      { name: 'Plantation' },
      { name: 'Boca Raton' },
      { name: 'Deltona' },
      { name: 'Largo' },
      { name: 'Deerfield Beach' },
      { name: 'Palm Coast' },
      { name: 'Melbourne' },
      { name: 'Boynton Beach' },
      { name: 'Lauderhill' },
      { name: 'Weston' },
      { name: 'Fort Myers' },
      { name: 'Kissimmee' },
      { name: 'Homestead' },
      { name: 'Tamarac' },
      { name: 'Delray Beach' },
      { name: 'Daytona Beach' },
      { name: 'North Miami' },
      { name: 'Wellington' },
      { name: 'North Port' },
      { name: 'Jupiter' },
      { name: 'Ocala' },
      { name: 'Port Orange' },
      { name: 'Margate' },
      { name: 'Coconut Creek' },
      { name: 'Sanford' },
      { name: 'Sarasota' },
      { name: 'Pensacola' },
      { name: 'Bradenton' },
      { name: 'Palm Beach Gardens' },
      { name: 'Pinellas Park' },
      { name: 'Coral Gables' },
      { name: 'Doral' },
      { name: 'Bonita Springs' },
      { name: 'Apopka' },
      { name: 'Titusville' },
      { name: 'North Miami Beach' },
      { name: 'Oakland Park' },
      { name: 'Fort Pierce' },
      { name: 'North Lauderdale' },
      { name: 'Cutler Bay' },
      { name: 'Altamonte Springs' },
      { name: 'St. Cloud' },
      { name: 'Greenacres' },
      { name: 'Ormond Beach' },
      { name: 'Ocoee' },
      { name: 'Hallandale Beach' },
      { name: 'Winter Garden' },
      { name: 'Aventura' },
    ],
  },
  {
    name: 'Indiana',
    cities: [
      { name: 'Indianapolis' },
      { name: 'Fort Wayne' },
      { name: 'Evansville' },
      { name: 'South Bend' },
      { name: 'Carmel' },
      { name: 'Bloomington' },
      { name: 'Fishers' },
      { name: 'Hammond' },
      { name: 'Gary' },
      { name: 'Muncie' },
      { name: 'Lafayette' },
      { name: 'Terre Haute' },
      { name: 'Kokomo' },
      { name: 'Anderson' },
      { name: 'Noblesville' },
      { name: 'Greenwood' },
      { name: 'Elkhart' },
      { name: 'Mishawaka' },
      { name: 'Lawrence' },
      { name: 'Jeffersonville' },
      { name: 'Columbus' },
      { name: 'Portage' },
    ],
  },
  {
    name: 'Ohio',
    cities: [
      { name: 'Columbus' },
      { name: 'Cleveland' },
      { name: 'Cincinnati' },
      { name: 'Toledo' },
      { name: 'Akron' },
      { name: 'Dayton' },
      { name: 'Parma' },
      { name: 'Canton' },
      { name: 'Youngstown' },
      { name: 'Lorain' },
      { name: 'Hamilton' },
      { name: 'Springfield' },
      { name: 'Kettering' },
      { name: 'Elyria' },
      { name: 'Lakewood' },
      { name: 'Cuyahoga Falls' },
      { name: 'Middletown' },
      { name: 'Euclid' },
      { name: 'Newark' },
      { name: 'Mansfield' },
      { name: 'Mentor' },
      { name: 'Beavercreek' },
      { name: 'Cleveland Heights' },
      { name: 'Strongsville' },
      { name: 'Dublin' },
      { name: 'Fairfield' },
      { name: 'Findlay' },
      { name: 'Warren' },
      { name: 'Lancaster' },
      { name: 'Lima' },
      { name: 'Huber Heights' },
      { name: 'Westerville' },
      { name: 'Marion' },
      { name: 'Grove City' },
    ],
  },
  {
    name: 'North Carolina',
    cities: [
      { name: 'Charlotte' },
      { name: 'Raleigh' },
      { name: 'Greensboro' },
      { name: 'Durham' },
      { name: 'Winston-Salem' },
      { name: 'Fayetteville' },
      { name: 'Cary' },
      { name: 'Wilmington' },
      { name: 'High Point' },
      { name: 'Greenville' },
      { name: 'Asheville' },
      { name: 'Concord' },
      { name: 'Gastonia' },
      { name: 'Jacksonville' },
      { name: 'Chapel Hill' },
      { name: 'Rocky Mount' },
      { name: 'Burlington' },
      { name: 'Wilson' },
      { name: 'Huntersville' },
      { name: 'Kannapolis' },
      { name: 'Apex' },
      { name: 'Hickory' },
      { name: 'Goldsboro' },
    ],
  },
  {
    name: 'Michigan',
    cities: [
      { name: 'Detroit' },
      { name: 'Grand Rapids' },
      { name: 'Warren' },
      { name: 'Sterling Heights' },
      { name: 'Ann Arbor' },
      { name: 'Lansing' },
      { name: 'Flint' },
      { name: 'Dearborn' },
      { name: 'Livonia' },
      { name: 'Westland' },
      { name: 'Troy' },
      { name: 'Farmington Hills' },
      { name: 'Kalamazoo' },
      { name: 'Wyoming' },
      { name: 'Southfield' },
      { name: 'Rochester Hills' },
      { name: 'Taylor' },
      { name: 'Pontiac' },
      { name: 'St. Clair Shores' },
      { name: 'Royal Oak' },
      { name: 'Novi' },
      { name: 'Dearborn Heights' },
      { name: 'Battle Creek' },
      { name: 'Saginaw' },
      { name: 'Kentwood' },
      { name: 'East Lansing' },
      { name: 'Roseville' },
      { name: 'Portage' },
      { name: 'Midland' },
      { name: 'Lincoln Park' },
      { name: 'Muskegon' },
    ],
  },
  {
    name: 'Tennessee',
    cities: [
      { name: 'Memphis' },
      { name: 'Nashville-Davidson' },
      { name: 'Knoxville' },
      { name: 'Chattanooga' },
      { name: 'Clarksville' },
      { name: 'Murfreesboro' },
      { name: 'Jackson' },
      { name: 'Franklin' },
      { name: 'Johnson City' },
      { name: 'Bartlett' },
      { name: 'Hendersonville' },
      { name: 'Kingsport' },
      { name: 'Collierville' },
      { name: 'Cleveland' },
      { name: 'Smyrna' },
      { name: 'Germantown' },
      { name: 'Brentwood' },
    ],
  },
  {
    name: 'Massachusetts',
    cities: [
      { name: 'Boston' },
      { name: 'Worcester' },
      { name: 'Springfield' },
      { name: 'Lowell' },
      { name: 'Cambridge' },
      { name: 'New Bedford' },
      { name: 'Brockton' },
      { name: 'Quincy' },
      { name: 'Lynn' },
      { name: 'Fall River' },
      { name: 'Newton' },
      { name: 'Lawrence' },
      { name: 'Somerville' },
      { name: 'Waltham' },
      { name: 'Haverhill' },
      { name: 'Malden' },
      { name: 'Medford' },
      { name: 'Taunton' },
      { name: 'Chicopee' },
      { name: 'Weymouth Town' },
      { name: 'Revere' },
      { name: 'Peabody' },
      { name: 'Methuen' },
      { name: 'Barnstable Town' },
      { name: 'Pittsfield' },
      { name: 'Attleboro' },
      { name: 'Everett' },
      { name: 'Salem' },
      { name: 'Westfield' },
      { name: 'Leominster' },
      { name: 'Fitchburg' },
      { name: 'Beverly' },
      { name: 'Holyoke' },
      { name: 'Marlborough' },
      { name: 'Woburn' },
      { name: 'Chelsea' },
    ],
  },
  {
    name: 'Washington',
    cities: [
      { name: 'Seattle' },
      { name: 'Spokane' },
      { name: 'Tacoma' },
      { name: 'Vancouver' },
      { name: 'Bellevue' },
      { name: 'Kent' },
      { name: 'Everett' },
      { name: 'Renton' },
      { name: 'Yakima' },
      { name: 'Federal Way' },
      { name: 'Spokane Valley' },
      { name: 'Bellingham' },
      { name: 'Kennewick' },
      { name: 'Auburn' },
      { name: 'Pasco' },
      { name: 'Marysville' },
      { name: 'Lakewood' },
      { name: 'Redmond' },
      { name: 'Shoreline' },
      { name: 'Richland' },
      { name: 'Kirkland' },
      { name: 'Burien' },
      { name: 'Sammamish' },
      { name: 'Olympia' },
      { name: 'Lacey' },
      { name: 'Edmonds' },
      { name: 'Bremerton' },
      { name: 'Puyallup' },
    ],
  },
  {
    name: 'Colorado',
    cities: [
      { name: 'Denver' },
      { name: 'Colorado Springs' },
      { name: 'Aurora' },
      { name: 'Fort Collins' },
      { name: 'Lakewood' },
      { name: 'Thornton' },
      { name: 'Arvada' },
      { name: 'Westminster' },
      { name: 'Pueblo' },
      { name: 'Centennial' },
      { name: 'Boulder' },
      { name: 'Greeley' },
      { name: 'Longmont' },
      { name: 'Loveland' },
      { name: 'Grand Junction' },
      { name: 'Broomfield' },
      { name: 'Castle Rock' },
      { name: 'Commerce City' },
      { name: 'Parker' },
      { name: 'Littleton' },
      { name: 'Northglenn' },
    ],
  },
  { name: 'District of Columbia', cities: [{ name: 'Washington' }] },
  {
    name: 'Maryland',
    cities: [
      { name: 'Baltimore' },
      { name: 'Frederick' },
      { name: 'Rockville' },
      { name: 'Gaithersburg' },
      { name: 'Bowie' },
      { name: 'Hagerstown' },
      { name: 'Annapolis' },
    ],
  },
  {
    name: 'Kentucky',
    cities: [
      { name: 'Louisville/Jefferson County' },
      { name: 'Lexington-Fayette' },
      { name: 'Bowling Green' },
      { name: 'Owensboro' },
      { name: 'Covington' },
    ],
  },
  {
    name: 'Oregon',
    cities: [
      { name: 'Portland' },
      { name: 'Eugene' },
      { name: 'Salem' },
      { name: 'Gresham' },
      { name: 'Hillsboro' },
      { name: 'Beaverton' },
      { name: 'Bend' },
      { name: 'Medford' },
      { name: 'Springfield' },
      { name: 'Corvallis' },
      { name: 'Albany' },
      { name: 'Tigard' },
      { name: 'Lake Oswego' },
      { name: 'Keizer' },
    ],
  },
  {
    name: 'Oklahoma',
    cities: [
      { name: 'Oklahoma City' },
      { name: 'Tulsa' },
      { name: 'Norman' },
      { name: 'Broken Arrow' },
      { name: 'Lawton' },
      { name: 'Edmond' },
      { name: 'Moore' },
      { name: 'Midwest City' },
      { name: 'Enid' },
      { name: 'Stillwater' },
      { name: 'Muskogee' },
    ],
  },
  {
    name: 'Wisconsin',
    cities: [
      { name: 'Milwaukee' },
      { name: 'Madison' },
      { name: 'Green Bay' },
      { name: 'Kenosha' },
      { name: 'Racine' },
      { name: 'Appleton' },
      { name: 'Waukesha' },
      { name: 'Eau Claire' },
      { name: 'Oshkosh' },
      { name: 'Janesville' },
      { name: 'West Allis' },
      { name: 'La Crosse' },
      { name: 'Sheboygan' },
      { name: 'Wauwatosa' },
      { name: 'Fond du Lac' },
      { name: 'New Berlin' },
      { name: 'Wausau' },
      { name: 'Brookfield' },
      { name: 'Greenfield' },
      { name: 'Beloit' },
    ],
  },
  {
    name: 'Nevada',
    cities: [
      { name: 'Las Vegas' },
      { name: 'Henderson' },
      { name: 'Reno' },
      { name: 'North Las Vegas' },
      { name: 'Sparks' },
      { name: 'Carson City' },
    ],
  },
  {
    name: 'New Mexico',
    cities: [
      { name: 'Albuquerque' },
      { name: 'Las Cruces' },
      { name: 'Rio Rancho' },
      { name: 'Santa Fe' },
      { name: 'Roswell' },
      { name: 'Farmington' },
      { name: 'Clovis' },
    ],
  },
  {
    name: 'Missouri',
    cities: [
      { name: 'Kansas City' },
      { name: 'St. Louis' },
      { name: 'Springfield' },
      { name: 'Independence' },
      { name: 'Columbia' },
      { name: "Lee's Summit" },
      { name: "O'Fallon" },
      { name: 'St. Joseph' },
      { name: 'St. Charles' },
      { name: 'St. Peters' },
      { name: 'Blue Springs' },
      { name: 'Florissant' },
      { name: 'Joplin' },
      { name: 'Chesterfield' },
      { name: 'Jefferson City' },
      { name: 'Cape Girardeau' },
    ],
  },
  {
    name: 'Virginia',
    cities: [
      { name: 'Virginia Beach' },
      { name: 'Norfolk' },
      { name: 'Chesapeake' },
      { name: 'Richmond' },
      { name: 'Newport News' },
      { name: 'Alexandria' },
      { name: 'Hampton' },
      { name: 'Roanoke' },
      { name: 'Portsmouth' },
      { name: 'Suffolk' },
      { name: 'Lynchburg' },
      { name: 'Harrisonburg' },
      { name: 'Leesburg' },
      { name: 'Charlottesville' },
      { name: 'Danville' },
      { name: 'Blacksburg' },
      { name: 'Manassas' },
    ],
  },
  {
    name: 'Georgia',
    cities: [
      { name: 'Atlanta' },
      { name: 'Columbus' },
      { name: 'Augusta-Richmond County' },
      { name: 'Savannah' },
      { name: 'Athens-Clarke County' },
      { name: 'Sandy Springs' },
      { name: 'Roswell' },
      { name: 'Macon' },
      { name: 'Johns Creek' },
      { name: 'Albany' },
      { name: 'Warner Robins' },
      { name: 'Alpharetta' },
      { name: 'Marietta' },
      { name: 'Valdosta' },
      { name: 'Smyrna' },
      { name: 'Dunwoody' },
    ],
  },
  {
    name: 'Nebraska',
    cities: [{ name: 'Omaha' }, { name: 'Lincoln' }, { name: 'Bellevue' }, { name: 'Grand Island' }],
  },
  {
    name: 'Minnesota',
    cities: [
      { name: 'Minneapolis' },
      { name: 'St. Paul' },
      { name: 'Rochester' },
      { name: 'Duluth' },
      { name: 'Bloomington' },
      { name: 'Brooklyn Park' },
      { name: 'Plymouth' },
      { name: 'St. Cloud' },
      { name: 'Eagan' },
      { name: 'Woodbury' },
      { name: 'Maple Grove' },
      { name: 'Eden Prairie' },
      { name: 'Coon Rapids' },
      { name: 'Burnsville' },
      { name: 'Blaine' },
      { name: 'Lakeville' },
      { name: 'Minnetonka' },
      { name: 'Apple Valley' },
      { name: 'Edina' },
      { name: 'St. Louis Park' },
      { name: 'Mankato' },
      { name: 'Maplewood' },
      { name: 'Moorhead' },
      { name: 'Shakopee' },
    ],
  },
  {
    name: 'Kansas',
    cities: [
      { name: 'Wichita' },
      { name: 'Overland Park' },
      { name: 'Kansas City' },
      { name: 'Olathe' },
      { name: 'Topeka' },
      { name: 'Lawrence' },
      { name: 'Shawnee' },
      { name: 'Manhattan' },
      { name: 'Lenexa' },
      { name: 'Salina' },
      { name: 'Hutchinson' },
    ],
  },
  {
    name: 'Louisiana',
    cities: [
      { name: 'New Orleans' },
      { name: 'Baton Rouge' },
      { name: 'Shreveport' },
      { name: 'Lafayette' },
      { name: 'Lake Charles' },
      { name: 'Kenner' },
      { name: 'Bossier City' },
      { name: 'Monroe' },
      { name: 'Alexandria' },
    ],
  },
  { name: 'Hawaii', cities: [{ name: 'Honolulu' }] },
  { name: 'Alaska', cities: [{ name: 'Anchorage' }] },
  {
    name: 'New Jersey',
    cities: [
      { name: 'Newark' },
      { name: 'Jersey City' },
      { name: 'Paterson' },
      { name: 'Elizabeth' },
      { name: 'Clifton' },
      { name: 'Trenton' },
      { name: 'Camden' },
      { name: 'Passaic' },
      { name: 'Union City' },
      { name: 'Bayonne' },
      { name: 'East Orange' },
      { name: 'Vineland' },
      { name: 'New Brunswick' },
      { name: 'Hoboken' },
      { name: 'Perth Amboy' },
      { name: 'West New York' },
      { name: 'Plainfield' },
      { name: 'Hackensack' },
      { name: 'Sayreville' },
      { name: 'Kearny' },
      { name: 'Linden' },
      { name: 'Atlantic City' },
    ],
  },
  {
    name: 'Idaho',
    cities: [
      { name: 'Boise City' },
      { name: 'Nampa' },
      { name: 'Meridian' },
      { name: 'Idaho Falls' },
      { name: 'Pocatello' },
      { name: 'Caldwell' },
      { name: "Coeur d'Alene" },
      { name: 'Twin Falls' },
    ],
  },
  {
    name: 'Alabama',
    cities: [
      { name: 'Birmingham' },
      { name: 'Montgomery' },
      { name: 'Mobile' },
      { name: 'Huntsville' },
      { name: 'Tuscaloosa' },
      { name: 'Hoover' },
      { name: 'Dothan' },
      { name: 'Auburn' },
      { name: 'Decatur' },
      { name: 'Madison' },
      { name: 'Florence' },
      { name: 'Gadsden' },
    ],
  },
  {
    name: 'Iowa',
    cities: [
      { name: 'Des Moines' },
      { name: 'Cedar Rapids' },
      { name: 'Davenport' },
      { name: 'Sioux City' },
      { name: 'Iowa City' },
      { name: 'Waterloo' },
      { name: 'Council Bluffs' },
      { name: 'Ames' },
      { name: 'West Des Moines' },
      { name: 'Dubuque' },
      { name: 'Ankeny' },
      { name: 'Urbandale' },
      { name: 'Cedar Falls' },
    ],
  },
  {
    name: 'Arkansas',
    cities: [
      { name: 'Little Rock' },
      { name: 'Fort Smith' },
      { name: 'Fayetteville' },
      { name: 'Springdale' },
      { name: 'Jonesboro' },
      { name: 'North Little Rock' },
      { name: 'Conway' },
      { name: 'Rogers' },
      { name: 'Pine Bluff' },
      { name: 'Bentonville' },
    ],
  },
  {
    name: 'Utah',
    cities: [
      { name: 'Salt Lake City' },
      { name: 'West Valley City' },
      { name: 'Provo' },
      { name: 'West Jordan' },
      { name: 'Orem' },
      { name: 'Sandy' },
      { name: 'Ogden' },
      { name: 'St. George' },
      { name: 'Layton' },
      { name: 'Taylorsville' },
      { name: 'South Jordan' },
      { name: 'Lehi' },
      { name: 'Logan' },
      { name: 'Murray' },
      { name: 'Draper' },
      { name: 'Bountiful' },
      { name: 'Riverton' },
      { name: 'Roy' },
    ],
  },
  {
    name: 'Rhode Island',
    cities: [
      { name: 'Providence' },
      { name: 'Warwick' },
      { name: 'Cranston' },
      { name: 'Pawtucket' },
      { name: 'East Providence' },
      { name: 'Woonsocket' },
    ],
  },
  {
    name: 'Mississippi',
    cities: [
      { name: 'Jackson' },
      { name: 'Gulfport' },
      { name: 'Southaven' },
      { name: 'Hattiesburg' },
      { name: 'Biloxi' },
      { name: 'Meridian' },
    ],
  },
  { name: 'South Dakota', cities: [{ name: 'Sioux Falls' }, { name: 'Rapid City' }] },
  {
    name: 'Connecticut',
    cities: [
      { name: 'Bridgeport' },
      { name: 'New Haven' },
      { name: 'Stamford' },
      { name: 'Hartford' },
      { name: 'Waterbury' },
      { name: 'Norwalk' },
      { name: 'Danbury' },
      { name: 'New Britain' },
      { name: 'Meriden' },
      { name: 'Bristol' },
      { name: 'West Haven' },
      { name: 'Milford' },
      { name: 'Middletown' },
      { name: 'Norwich' },
      { name: 'Shelton' },
    ],
  },
  {
    name: 'South Carolina',
    cities: [
      { name: 'Columbia' },
      { name: 'Charleston' },
      { name: 'North Charleston' },
      { name: 'Mount Pleasant' },
      { name: 'Rock Hill' },
      { name: 'Greenville' },
      { name: 'Summerville' },
      { name: 'Sumter' },
      { name: 'Goose Creek' },
      { name: 'Hilton Head Island' },
      { name: 'Florence' },
      { name: 'Spartanburg' },
    ],
  },
  { name: 'New Hampshire', cities: [{ name: 'Manchester' }, { name: 'Nashua' }, { name: 'Concord' }] },
  {
    name: 'North Dakota',
    cities: [{ name: 'Fargo' }, { name: 'Bismarck' }, { name: 'Grand Forks' }, { name: 'Minot' }],
  },
  {
    name: 'Montana',
    cities: [{ name: 'Billings' }, { name: 'Missoula' }, { name: 'Great Falls' }, { name: 'Bozeman' }],
  },
  { name: 'Delaware', cities: [{ name: 'Wilmington' }, { name: 'Dover' }] },
  { name: 'Maine', cities: [{ name: 'Portland' }] },
  { name: 'Wyoming', cities: [{ name: 'Cheyenne' }, { name: 'Casper' }] },
  { name: 'West Virginia', cities: [{ name: 'Charleston' }, { name: 'Huntington' }] },
  { name: 'Vermont', cities: [{ name: 'Burlington' }] },
];

export const getStatesAndCities = (limitCities = Number.MAX_SAFE_INTEGER) => {
  const allStates = states;

  return allStates.map(state => ({
    name: state.name,
    children: state.cities.slice(0, limitCities),
  }));
};
